{$F+}
Unit
	pltsnfr; { Polit Halcyon pltsnfr application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Popup;

Type
	TpltsnfrData=Record
		{ i i ணࠬ  ,  쮬 i }
          clickState:integer;
          programState:integer;
          ButtonProg:PControl;
          kilkBomb:integer;
          minesAll:PControl;
          stateButton:PControl;
          buttons:array[1..16, 1..16] of record
              state:integer;
              bomb:boolean;
              Btn:Pcontrol;
            end;
	End;

Implementation

procedure NewGame(Me:PProg);
var
   i,j:integer;
   s:string;
begin
   With Me^, ClientRect, TpltsnfrData(Data^) Do
     kilkBomb:=0;
   for i:=1 to 16 do
     for j:=1 to 16 do
       With Me^, ClientRect, TpltsnfrData(Data^) Do
         begin
           Button_SetDown(buttons[i,j].btn, false);
           Button_SetCaption(buttons[i,j].btn, ' ');
           buttons[i,j].state:=0;
           if random<0.15625 then
             buttons[i,j].bomb:=true
           else
             buttons[i,j].bomb:=false;
           if buttons[i,j].bomb then kilkBomb:=kilkBomb+1;
         end;
   With Me^, ClientRect, TpltsnfrData(Data^) Do
     begin
       str(kilkBomb,s);
       Button_SetCaption(minesAll, s);
       programState:=0;
     end;
end;


procedure NewButtonClick(Me:PProg; Button:PControl);
begin
  NewGame(Me);
  PaintWindow(Me);
end;

procedure StateButtonClick(Me:PProg; Button:PControl);
begin
  With Me^, ClientRect, TpltsnfrData(Data^) Do
    if programState=1 then
      programState:=0
    else
      programState:=1;
   With Me^, ClientRect, TpltsnfrData(Data^) Do
    if programState=1 then
      Button_SetCaption(stateButton, ' i')
    else
      Button_SetCaption(stateButton, ' i');
  PaintWindow(Me);
end;

procedure ButtonsClick(Me:PProg; Button:PControl);
var
   i,j:integer;
   i1,j1:integer;
   k:integer;
   s:string;
   u:boolean;
begin
 With Me^, ClientRect, TpltsnfrData(Data^) Do
  begin
   i1:=1;
   j1:=1;
   for i:=1 to 16 do
     for j:=1 to 16 do
       begin
          if Button=buttons[i,j].Btn then
            begin
             i1:=i;
             j1:=j;
             break;
            end;
       end;
   if programState=1 then
     begin
       if buttons[i1,j1].state=0 then
         begin
           Button_SetCaption(buttons[i1,j1].btn, 'M');
           buttons[i1,j1].state:=1;
         end
       else
         begin
           Button_SetCaption(buttons[i1,j1].btn, ' ');
           buttons[i1,j1].state:=0;
         end;
       u:=true;
       for i:=1 to 16 do
         for j:=1 to 16 do
           if ((buttons[i,j].bomb) <> (buttons[i,j].state=1)) then
             u:=false;
       if u then NewGame(Me);
       PaintWindow(Me);
       exit;
     end;
   if buttons[i1,j1].bomb then
     begin
       Button_SetCaption(Button, '*');
       for i:=1 to 16 do
         for j:=1 to 16 do
          begin
            if buttons[i,j].bomb then
              begin
                Button_SetCaption(buttons[i,j].btn, '*');
                Button_SetDown(buttons[i,j].btn, false)
              end
            else
              begin
                Button_SetCaption(buttons[i,j].btn, ' ');
                Button_SetDown(buttons[i,j].btn, true)
              end;
          end;
       PaintWindow(Me);
     end
   else
     begin
       buttons[i1,j1].state:=1;
       k:=0;
       if (i1<>1) and (j1<>1) then
         if buttons[i1-1,j1-1].bomb then inc(k);
       if (i1<>1) then
         if buttons[i1-1,j1].bomb then inc(k);
       if (i1<>16) then
         if buttons[i1+1,j1].bomb then inc(k);
       if (i1<>16) and (j1<>16) then
         if buttons[i1+1,j1+1].bomb then inc(k);
       if (j1<>16) then
         if buttons[i1,j1+1].bomb then inc(k);
       if (i1<>1) and (j1<>16) then
         if buttons[i1-1,j1+1].bomb then inc(k);
       if (j1<>1) then
         if buttons[i1,j1-1].bomb then inc(k);
       if (i1<>16) and (j1<>1) then
         if buttons[i1+1,j1-1].bomb then inc(k);
       str(k,s);
       Button_SetCaption(Button, s);
       Button_SetDown(Button, true);
     end;
  end;
end;


Procedure OnPaint(Me:PProg);
var
   i,j:integer;
Begin
	With Me^, ClientRect, TpltsnfrData(Data^) Do
	Begin
		{ i   i i                         }
		{ 砩 ⮡i ॡ   i  㢠 }
          Ctl.Button_Paint(ButtonProg, 50,10,100);
          Ctl.Button_Paint(stateButton, 200,10,300);
          Ctl.Label_Paint(minesAll, 10,10,40);
          for i:=1 to 16 do
            for j:=1 to 16 do
              Ctl.Button_Paint(buttons[i,j].Btn, 1+((i-1)*20),41+((j-1)*20),22+((i-1)*20)-2);
	End;
End;

Procedure OnClose(Me:PProg);
Begin
	{ i   i i }
	{   OnInit   ' (GetMem, New)  ⠦ }
	{  (Kernel.LoadRes),   ॡ  i      }
	FreeMem(Me^.Data, SizeOf(TpltsnfrData))
End;

Procedure OnInit(Me:PProg);
var
   i,j:integer;
Begin
	{ i    ணࠬ }
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('', WinTitle);
		MinX:=330;
		MinY:=365;
		GetMem(Data, SizeOf(TpltsnfrData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbClose]);
		Kernel.DrawWindowAni(Me);

		With TpltsnfrData(Data^) Do
		Begin
			{  -  i  ⢮७ i i 㢠 }
                  minesAll:=ctl.Label_Create(Me, '  ', nil, lsBeveled, alCenter);
                  ButtonProg:=ctl.Button_Create(Me, ' ', NIL, ppLeft, NewButtonClick);
                  stateButton:=ctl.Button_Create(Me, ' i', NIL, ppLeft, StateButtonClick);
                  for i:=1 to 16 do
                    for j:=1 to 16 do
                     buttons[i,j].btn:=ctl.Button_Create(Me, ' ', NIL, ppLeft, ButtonsClick);
                  aCTIVEcTL:=nIL;
                  NewGame(Me);
		End
	End
End;



Begin
	Kernel.RegBuiltIn('pltsnfr', ' ""', 'pic\i_app.bmp', OnInit)
End.
